/*******************************************************************************
 * Copyright (c) 2003, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/


import org.mozilla.xpcom.*;

class MozillaHelperAppLauncherDialog implements nsIHelperAppLauncherDialog {

  public MozillaHelperAppLauncherDialog() {
  }

  public nsISupports queryInterface(String aIID) {
      return Mozilla.queryInterface(this, aIID);
  }

  /* nsIHelperAppLauncherDialog */

  public void show(nsIHelperAppLauncher aLauncher, nsISupports aContext, long aForced) {
    aLauncher.saveToDisk(null, false);
  }

  public nsILocalFile promptForSaveToFile(nsIHelperAppLauncher aLauncher, nsISupports aWindowContext, String aDefaultFile, String aSuggestedFileExtension) {
    System.out.println("promptForSaveToFile");
    return Mozilla.getInstance().newLocalFile("c:/temp/dd.", true);
  }
}